--**********************************************************--

--***********SONIC AEROBOARD by DARK_WOLF***********--
--Version 1.0  Auf PSPMulti  and little German Part by D!S
--**********************************************************--

dofile "ms0:/PSP/GAME/PSPMulti/Sonic/scripts/cores.lua"

backgroundA = Image.load("ms0:/PSP/GAME/PSPMulti/Sonic/images/background1.png") 
backgroundB = Image.load("ms0:/PSP/GAME/PSPMulti/Sonic/images/background2.png") 
objecto = Image.load("ms0:/PSP/GAME/PSPMulti/Sonic/images/object.png") 
objecto2 = Image.load("ms0:/PSP/GAME/PSPMulti/Sonic/images/object2.png") 
oponente = Image.load("ms0:/PSP/GAME/PSPMulti/Sonic/images/enemy.png")
stand = Image.load("ms0:/PSP/GAME/PSPMulti/Sonic/Personagens/stand.png") 
life = Image.load("ms0:/PSP/GAME/PSPMulti/Sonic/Personagens/life.png") 

currentBullet = 0
direction = "right"
bullet = Image.createEmpty(4,4)
bullet:clear(vermelho)

Player = {} 
Player.gravity = 200
Player.x = 80
Player.y = 20 
Player.img = stand
Player.life = 100
Player.jumpspeed = 10
Player.jumpstate = "chao" 
Player.width = 45
Player.height = 43
Player.score = 0 

Enemy = {} 
Enemy.gravity = 200
Enemy.x = math.random(480,600) 
Enemy.y = 182 
Enemy.img = oponente 
Enemy.life = 100 
Enemy.width = 75;
Enemy.height = 62;

BulletInfo = {} 
for a = 1,5 do
BulletInfo[a] = { pic = bullet , firing = false, direction = "down", x = Player.x + 32, 
y = Player.y + 16, largeur = 4, hauteur = 4 }
end

obj = {
   x = math.random(600,1000);
   y = math.random(150,250);
   width = 20;
   height = 20;
   img = objecto
}

obj2 = {
   x = math.random(600,1000);
   y = math.random(150,250);
   width = 20;
   height = 20;
   img = objecto2
}

Timer = 0

function bulletSetup()
if currentBullet < 5 then
currentBullet = currentBullet + 1
else
currentBullet = 1
end

if direction == "left" then 
BulletInfo[currentBullet].x = Player.x 
BulletInfo[currentBullet].y = Player.y + 16
end
if direction == "right" then 
BulletInfo[currentBullet].x = Player.x + 32 
BulletInfo[currentBullet].y = Player.y + 16 
end

BulletInfo[currentBullet].direction = direction
BulletInfo[currentBullet].firing = true
end

function bulletFire()
for a = 1,5 do
if BulletInfo[a].firing == true then
if BulletInfo[a].direction == "right" then BulletInfo[a].x = BulletInfo[a].x + 10 end
if BulletInfo[a].direction == "left" then BulletInfo[a].x = BulletInfo[a].x - 10 end
if BulletInfo[a].x + 4 > Enemy.x and BulletInfo[a].x < Enemy.x + 32 and BulletInfo[a].y + 4 > Enemy.y and BulletInfo[a].y < Enemy.y + Enemy.height then
hit1 = "true"
Enemy.life = Enemy.life - 10
BulletInfo[a].firing = false
break
else
screen:blit(BulletInfo[a].x,BulletInfo[a].y,BulletInfo[a].pic)
end
end
if BulletInfo[a].x < 0 or BulletInfo[a].x > 480 or BulletInfo[a].y < 0 or BulletInfo[a].y > 272 then 
BulletInfo[a].firing = false 
end
end
end

Background1 = {x = 0, y = 0}
Background2 = {x = 480, y = 0}

backgroundWidth = 480
backgroundHeight = 272

function scroll() 
Background1.x = Background1.x - 10 
Background2.x = Background2.x - 10 
if Background1.x + backgroundWidth <= 0 then
Background1.x = Background2.x + backgroundWidth
end
if Background2.x + backgroundWidth <= 0 then
Background2.x = Background1.x + backgroundWidth
end
end 

function velocidade() 
Background1.x = Background1.x - 20 
Background2.x = Background2.x - 20 
obj.x = obj.x - 12
obj2.x = obj2.x - 12
Enemy.x = Enemy.x - 4
end 

function gravity()
if Player.gravity < 0 then
Player.jumpstate = "falling"
end 
if Player.gravity < 200 and Player.jumpstate == "falling" then
Player.gravity = Player.gravity + (Player.jumpspeed + 10)
end 
if Player.gravity == 200 then
Player.jumpspeed = 10
Player.jumpstate = "chao"
end
if Player.gravity > 200 then Player.gravity = 200 end 

Player.y = Player.gravity
end

function parede()
if Player.x >= 450 then
Player.x = 450
end
if Player.x <= -15 then
Player.x = -15
end
end

function esquerda()
Timer = Timer + 1
if Timer>=8 or Timer<= 0 then
Timer = 0 
end
if Timer == 5 then
Player.img = stand
end
end

function direita()
Timer = Timer + 1
if Timer>=8 or Timer<= 0 then
Timer = 0 
end
if Timer==5 then
Player.img = stand
end
end

function controls()
if pad:left() then
esquerda()
Player.x = Player.x - 4
end 

if pad:right() then
direita()
Player.x = Player.x + 4
end

if pad:cross() and Player.jumpstate == "chao" then Player.jumpstate = "jumping" 
end 
if Player.jumpstate == "jumping" then
Player.jumpspeed = Player.jumpspeed - 0.5
Player.gravity = Player.gravity - Player.jumpspeed
end 

if pad:square() and oldpad:square() ~= pad:square() then
bulletSetup()
end

if pad:r() then
velocidade()
end

if pad:start()then
pausa()
end

if pad:select()then
reiniciar()
end

end

function reiniciar()
selector=0
seta = Image.createEmpty(10,10)
seta:clear(vermelho)
while true do
screen:clear()
pad = Controls.read()
screen:print(220,20,"Quit?",branco)
screen:print(41,123,"YES",branco)
screen:print(41,156,"NO",branco)
if pad:down() and not oldpad:down() then selector = selector +1
elseif pad:up() and not oldpad:up() then selector = selector -1
end
if selector < 1 then selector = 2 
elseif selector > 2 then selector = 1 end 
if selector == 1 then screen:blit(30,123, seta) end
if selector == 2 then screen:blit(30,156, seta) end
if pad:cross() and not oldpad:cross() and selector == 1 then
dofile("ms0:/PSP/GAME/PSPMulti/SCRIPT.lua")
end
if pad:cross() and selector == 2 then
frommenu=false
break
end
oldpad = pad
screen.waitVblankStart()
screen:flip()
end
end

function pausa()
while true do
screen:clear()
screen:print(240,30,"Brake",branco)
screen:print(220,50,"Press O to return to Game",branco)
pad = Controls.read()
if pad:circle() then
frommenu=false
break
end
screen.waitVblankStart()
screen:flip()
end
end

function objcolisions()
obj.x = obj.x - 6
obj2.x = obj2.x - 6

if obj.x < -10 then obj.x = math.random(600,1000) end
if obj2.x < 10 then obj2.x = math.random(600,1000) end

if (Player.x + Player.width > obj.x) and (Player.x < obj.x + obj.width) and (Player.y + Player.height > obj.y) and (Player.y < obj.y + obj.height) then 
     Player.life = Player.life - 5
   obj.x = math.random(600,1000)
   obj.y = math.random(150,250)
   end
   
if (Player.x + Player.width > obj2.x) and (Player.x < obj2.x + obj2.width) and (Player.y + Player.height > obj2.y) and (obj.y < obj2.y + obj2.height) then 
     Player.life = Player.life - 5
   obj2.x = math.random(600,1000)
   obj2.y = math.random(150,250)
   end
   end

function enemycolisions()
Enemy.x = Enemy.x - 2
if Enemy.x < -75 then 
Enemy = {} 
Enemy.gravity = 200
Enemy.x = math.random(480,600)
Enemy.y = 182 
Enemy.img = oponente 
Enemy.life = 100 
Enemy.width = 75;
Enemy.height = 62;
end
if (Player.x + Player.width > Enemy.x) and (Player.x < Enemy.x + Enemy.width) and (Player.y + Player.height > Enemy.y) and (Player.y < Enemy.y + Enemy.height) then 
   Player.life = Player.life - 0.1
   end
   end

function enemydead()
if Enemy.life <= 0 then 
Player.score = Player.score + 10
Enemy = {} 
Enemy.gravity = 200
Enemy.x = math.random(480,600)
Enemy.y = 182 
Enemy.img = oponente 
Enemy.life = 100 
Enemy.width = 75;
Enemy.height = 62;
end
end

function morrer()
if Player.life <= 0 then
gameover()
end
end

function gameover()
while true do
screen:clear()
screen:print(240,136,"GAME OVER",branco)
screen:print(220,150,"Press Start play !",branco)
pad = Controls.read()
if pad:start() then
dofile("ms0:/PSP/GAME/PSPMulti/Sonic/scripts/game.lua")
end
screen.waitVblankStart()
screen:flip()
end
end

function win()
if Player.score >= 100 then
dofile("ms0:/PSP/GAME/PSPMulti/Sonic/scripts/win.lua")
file:close()
end
end

while true do
pad = Controls.read() 
oldpad = Controls.read() 
screen:clear()

scroll()
controls()
gravity()
parede()
objcolisions()
enemycolisions()
enemydead() 
morrer()
win()

screen:blit(Background1.x, Background1.y, backgroundA) 
screen:blit(Background2.x, Background2.y, backgroundB) 
screen:blit(obj.x, obj.y, obj.img)
screen:blit(obj2.x, obj2.y, obj2.img)
screen:blit(Enemy.x,Enemy.y,Enemy.img)
screen:blit(Player.x, Player.y, Player.img)
bulletFire()
screen:blit(10,10,life)
screen:fillRect(60,30,100,4,vermelho)
screen:fillRect(60,30,Player.life,4,azul)
screen:fillRect(Enemy.x - 10,Enemy.y - 10,Enemy.life,5, vermelho)
screen:print(300,10,"Score: "..Player.score,vermelho)

screen.waitVblankStart()
screen.flip()
end

